<ul class="breadcrumb">
    <li><a href="<?= $this->url('root') ?>"><?= $this->icon('home') ?></a></li>
    <li><?= $this->translate('budget_module_title') ?></li>
    <li class="active"><?= $this->translate('account_module_title') ?></li>
</ul>

<h1 class="page-title">
    <?= $this->icon('account') ?> <?= $this->translate('account_module_title') ?>
</h1>

<div class="row row-padding">
    <div class="col-xs-12">
        <div class="panel" ng-controller="accountListController as self">
            <table-builder options="self.options" items="self.accounts" class="table-builder">
                <div class="panel-heading">
                    <?= $this->translate('account_nav_list') ?>
                    <div class="panel-heading-right">
                        <div class="panel-heading-actions" tooltip="<?= $this->translate('tooltip_export_xls') ?>">
                            <?= $this->icon('excel', 'fa-fw pointer', ['ng-click' => '__tb.exportExcel()']) ?>
                        </div>
                        <div class="panel-heading-actions" tooltip="<?= $this->translate('tooltip_refresh') ?>">
                            <?= $this->icon('refresh', 'fa-fw pointer', ['ng-click' => '__tb.loadData()']) ?>
                        </div>
                    </div>
                </div>
                <div class="panel-body">
                    <div class="row">
                        <div class="col-sm-4">
                            <div class="table-filters little-panel">
                                <div class="title table-filters-header">
                                    <div class="input-group">
                                        <div class="input-group-addon pointer" data-toggle="collapse" href="#filters-collapsed">
                                            <?= $this->icon('filters', 'fa-fw') ?>
                                            <span class="caret"></span>
                                        </div>
                                        <input type="text" placeholder="<?= $this->translate('search', null, null, false) ?>" class="form-control" ng-model="self.fullText" id="full-text" on-enter="self.fullTextSearch()" />
                                        <div class="input-group-addon pointer" ng-click="self.fullTextSearch()">
                                            <?= $this->icon('search', 'fa-fw') ?>
                                        </div>
                                    </div>
                                </div>
                                <div id="filters-collapsed" class="body collapse">
                                    <?php

                                    $filters = [
                                        'id'      => [
                                            'label' => $this->translate('account_field_id'),
                                            'type'  => 'string',
                                        ],
                                        'code'      => [
                                            'label' => $this->translate('account_field_code'),
                                            'type'  => 'string',
                                        ],
                                        'name'      => [
                                            'label' => $this->translate('account_field_name'),
                                            'type'  => 'string',
                                        ],
                                        'description'      => [
                                            'label' => $this->translate('account_field_description'),
                                            'type'  => 'string',
                                        ],
                                        'type'      => [
                                            'label' => $this->translate('account_field_type'),
                                            'type'  => 'manytoone',
                                            'options' => [
                                                [
                                                    'value' => 'expense',
                                                    'text'  => $this->translate('account_expense'),
                                                ],
                                                [
                                                    'value' => 'income',
                                                    'text'  => $this->translate('account_income'),
                                                ],
                                            ]
                                        ],
                                        'parent.id'      => [
                                            'label' => $this->translate('account_field_parent.id'),
                                            'type'  => 'string',
                                        ],
                                        'parent.name'      => [
                                            'label' => $this->translate('account_field_parent.name'),
                                            'type'  => 'string',
                                        ],
                                        'createdAt' => [
                                            'label' => $this->translate('account_field_createdAt'),
                                            'type'  => 'date',
                                        ],
                                        'updatedAt' => [
                                            'label' => $this->translate('account_field_updatedAt'),
                                            'type'  => 'date',
                                        ],
                                    ];

                                    echo $this->tableFilter('__tb.apiParams.search.data.filters', $filters);
                                    ?>
                                    <div class="row">
                                        <div class="col-xs-6">
                                            <button class="btn" ng-click="self.resetfullTextSearch(); __tb.resetFilters(); __tb.loadData()"><?= $this->translate('table_filter_reset_button') ?></button>
                                        </div>
                                        <div class="col-xs-6 text-right">
                                            <button class="btn" ng-click="self.resetfullTextSearch(); __tb.loadData()">
                                                <?= $this->icon('search', 'fa-fw') ?>
                                                <?= $this->translate('table_filter_button') ?>
                                            </button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-sm-4">
                            <table-builder-columns></table-builder-columns>
                        </div>
                        <?php if ($this->acl()->isAllowed('application:e:query:r')) : ?>
                            <div class="col-sm-4">
                                <table-builder-queries></table-builder-queries>
                            </div>
                        <?php endif; ?>
                    </div>
                    <div class="row">
                        <div class="col-xs-12">
                            <div ng-show="__tb.isAnItemSelected()" class="btn-group">
                                <button ng-click="__tb.removeFromList()" class="btn btn-xs" type="button" tooltip="<?= $this->translate('tooltip_remove_from_list') ?>">
                                    <?= $this->icon('eraser') ?>
                                </button>

                                <?php if ($this->acl()->isAllowed('budget:e:account:d')) : ?>
                                    <button ng-click="self.showFusionModal()" class="btn btn-xs" type="button" tooltip="<?= $this->translate('fusion') ?>">
                                        <?= $this->icon('fusion') ?>
                                    </button>
                                <?php endif ?>
                            </div>
                            <form name="accountForm">
                                <table table-builder-table class="table table-bordered table-condensed table-hover">
                                    <thead>
                                        <tr>
                                            <th tb-column tb-name="selection" class="checkbox-column"><input type="checkbox" ng-model="__tb.selection" /></th>
                                            <th tb-column tb-name="id"   tb-sortable="true" tb-toggle="true"><?= $this->translate('account_field_id') ?></th>
                                            <th tb-column tb-name="code" tb-sortable="true" tb-toggle="true"><?= $this->translate('account_field_code') ?></th>
                                            <th tb-column tb-name="name" tb-sortable="true" tb-toggle="true"><?= $this->translate('account_field_name') ?></th>
                                            <th tb-column tb-name="description" tb-sortable="true" tb-toggle="true"><?= $this->translate('account_field_description') ?></th>
                                            <th tb-column tb-name="type" tb-sortable="true" tb-toggle="true"><?= $this->translate('account_field_type'); ?></th>
                                            <th tb-column tb-name="default" tb-sortable="true" tb-toggle="true"><?= $this->translate('account_field_default'); ?></th>
                                            <th tb-column tb-name="parent.id" tb-sortable="true" tb-toggle="true"><?= $this->translate('account_field_parent.id'); ?></th>
                                            <th tb-column tb-name="parent.name" tb-sortable="true" tb-toggle="true"><?= $this->translate('account_field_parent.name'); ?></th>
                                            <th tb-column tb-name="createdAt" tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate('account_field_createdAt') ?></th>
                                            <th tb-column tb-name="updatedAt" tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate('account_field_updatedAt') ?></th>
                                            <th tb-column tb-name="actions" class="actions-column"></th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr class="group">
                                            <td colspan="10"><?= $this->translate('account_type_expense') ?></td>
                                        </tr>
                                        <tr ng-repeat="account in self.accounts | filter : {type: '<?= \Budget\Entity\Account::TYPE_EXPENSE ?>'}" ng-class="{editing: self.editedLine == account}">
                                            <td><input type="checkbox" ng-model="account.selected" /></td>
                                            <td>{{account.id}}</td>
                                            <td class="editable" ng-style="{paddingLeft: (5 + account._level * 15) + 'px'}">
                                                <span ng-show="self.editedLine !== account">
                                                    {{account.code}}
                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(account)', 'ng-if' => 'account._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == account">
                                                    <input type="text" class="form-control input-sm" ng-model="self.editedLineFields.code" />
                                                    <field-errors field="code" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== account">
                                                    <a ng-if="account._rights.read" href="<?= $this->url('budget/account/form') ?>/{{account.id}}">{{account.name}}</a>
                                                    <span ng-if="!account._rights.read">{{account.name}}</span>

                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(account)', 'ng-if' => 'account._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == account">
                                                    <input type="text" class="form-control input-sm" ng-model="self.editedLineFields.name" required />
                                                    <field-errors field="name" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== account">
                                                    {{account.description}}
                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(account)', 'ng-if' => 'account._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == account">
                                                    <input type="text" class="form-control input-sm" ng-model="self.editedLineFields.description" required />
                                                    <field-errors field="description" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== account">
                                                    <?= $this->translate('account_type_expense')?>
                                                </span>
                                            </td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== account">
                                                    {{ account.default ? 'Oui' : 'Non'}}
                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(account)', 'ng-if' => 'account._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == account">
                                                    <input type="checkbox" ng-model="self.editedLineFields.default" />
                                                </span>
                                            </td>
                                            <td>{{account.parentOld.id}}</td>
                                            <td>{{account.parentOld.name}}</td>
                                            <td>{{account.createdAt | dateFormat : 'DD/MM/YYYY'}}</td>
                                            <td>{{account.updatedAt | dateFormat : 'DD/MM/YYYY'}}</td>
                                            <td>
                                                <div class="btn-group btn-group-actions" ng-if="self.editedLine !== account">
                                                    <?php if ($this->acl()->isAllowed('budget:e:account:r')) : ?>
                                                        <a ng-if="account._rights.read" href="<?= $this->url('budget/account/form') ?>/{{account.id}}" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_edit') ?>">
                                                            <?= $this->icon('edit') ?>
                                                        </a>
                                                    <?php endif; ?>

                                                    <?php if ($this->acl()->isAllowed('budget:e:account:d')) : ?>
                                                        <a ng-if="account._rights.delete" href="" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_delete') ?>" ng-click="self.deleteAccount(account)">
                                                            <?= $this->icon('delete') ?>
                                                        </a>
                                                    <?php endif; ?>
                                                </div>
                                                <div class="btn-group btn-group-actions" ng-if="self.editedLine == account">
                                                    <button class="btn btn-xs btn-default" ng-click="self.saveEditedLine(account)" type="submit" tooltip="<?= $this->translate('tooltip_save') ?>">
                                                        <?= $this->icon('save') ?>
                                                    </button>
                                                    <button class="btn btn-xs btn-default" ng-click="self.editedLine = null" type="button" tooltip="<?= $this->translate('tooltip_cancel') ?>">
                                                        <?= $this->icon('close') ?>
                                                    </button>
                                                </div>
                                            </td>
                                        </tr>
                                        <tr class="group">
                                            <td colspan="10"><?= $this->translate('account_type_income') ?></td>
                                        </tr>
                                        <tr ng-repeat="account in self.accounts | filter : {type: '<?= \Budget\Entity\Account::TYPE_INCOME ?>'}" ng-class="{editing: self.editedLine == account}">
                                            <td><input type="checkbox" /></td>
                                            <td>{{account.id}}</td>

                                            <td class="editable" ng-style="{paddingLeft: (5 + account._level * 15) + 'px'}">
                                                <span ng-show="self.editedLine !== account">
                                                    {{account.code}}
                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(account)', 'ng-if' => 'account._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == account">
                                                    <input type="text" class="form-control input-sm" ng-model="self.editedLineFields.code" />
                                                    <field-errors field="code" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== account">
                                                    <?php if ($this->acl()->isAllowed('budget:e:account:r')) : ?>
                                                        <a href="<?= $this->url('budget/account/form') ?>/{{account.id}}">{{account.name}}</a>
                                                    <?php else : ?>
                                                        {{account.name}}
                                                    <?php endif; ?>
                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(account)', 'ng-if' => 'account._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == account">
                                                    <input type="text" class="form-control input-sm" ng-model="self.editedLineFields.name" required />
                                                    <field-errors field="name" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== account">
                                                    {{account.description}}
                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(account)', 'ng-if' => 'account._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == account">
                                                    <input type="text" class="form-control input-sm" ng-model="self.editedLineFields.description" required />
                                                    <field-errors field="description" errors="self.editedLineErrors"></field-errors>
                                                </span>
                                            </td>
                                            <td>
                                                <span ng-show="self.editedLine !== account">
                                                    <?= $this->translate('account_type_income')?>
                                                </span>
                                            </td>
                                            <td class="editable">
                                                <span ng-show="self.editedLine !== account">
                                                    {{ account.default ? 'Oui' : 'Non'}}
                                                    <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(account)', 'ng-if' => 'account._rights.update']) ?>
                                                </span>
                                                <span ng-if="self.editedLine == account">
                                                    <input type="checkbox" ng-model="self.editedLineFields.default" />
                                                </span>
                                            </td>
                                            <td>{{account.parentOld.id}}</td>
                                            <td>{{account.parentOld.name}}</td>
                                            <td>{{account.createdAt | dateFormat : 'DD/MM/YYYY'}}</td>
                                            <td>{{account.updatedAt | dateFormat : 'DD/MM/YYYY'}}</td>
                                            <td>
                                                <div class="btn-group btn-group-actions" ng-if="self.editedLine !== account">
                                                    <?php if ($this->acl()->isAllowed('budget:e:account:r')) : ?>
                                                        <a ng-if="account._rights.read" href="<?= $this->url('budget/account/form') ?>/{{account.id}}" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_edit') ?>">
                                                            <?= $this->icon('edit') ?>
                                                        </a>
                                                    <?php endif; ?>

                                                    <?php if ($this->acl()->isAllowed('budget:e:account:d')) : ?>
                                                        <a ng-if="account._rights.delete" href="" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_delete') ?>" ng-click="self.deleteAccount(account)">
                                                            <?= $this->icon('delete') ?>
                                                        </a>
                                                    <?php endif; ?>
                                                </div>
                                                <div class="btn-group btn-group-actions" ng-if="self.editedLine == account">
                                                    <button class="btn btn-xs btn-default" ng-click="self.saveEditedLine(account)" type="submit" tooltip="<?= $this->translate('tooltip_save') ?>">
                                                        <?= $this->icon('save') ?>
                                                    </button>
                                                    <button class="btn btn-xs btn-default" ng-click="self.editedLine = null" type="button" tooltip="<?= $this->translate('tooltip_cancel') ?>">
                                                        <?= $this->icon('close') ?>
                                                    </button>
                                                </div>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </form>
                        </div>
                    </div>
                </div>
            </table-builder>

            <div class="modal" id="fusionModal">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h4 class="modal-title"><?= $this->translate('account_fusion_title') ?></h4>
                        </div>
                        <div class="modal-body">
                            <div class="row" style="margin-bottom: 10px;">
                                <div class="col-xs-12">
                                    <label for="fusion.keep">
                                        <?= $this->translate('fusion_field_accountToKeep') ?>
                                    </label>
                                    <account-select ng-model="self.fusion.keep"></account-select>
                                </div>
                            </div>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-default" type="button" data-dismiss="modal">
                                <?= $this->translate('close') ?>
                            </button>

                            <button class="btn btn-submit" ng-disabled="self.loading.fusion" ng-click="self.doFusion()">
                                <?= $this->icon('loading', '', ['ng-if' => 'self.loading.fusion']) ?>
                                <?= $this->translate('fusion') ?>
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<?php
$fabLinks = [];

if ($this->acl()->isAllowed('budget:e:account:c')) {
    $fabLinks[] = [
        'href' => $this->url('budget/account/form'),
        'text' => $this->icon('create', 'fa-fw') . ' ' . $this->translate('account_nav_form'),
    ];
    $fabLinks[] = [
        'href' => $this->url('import', ['entity' => 'account']),
        'text' => $this->icon('import', 'fa-fw') . ' ' . $this->translate('account_nav_import'),
    ];
}

echo $this->fabMenu($fabLinks);

$this->angular('js/src/budget/service/account.js');
$this->angular('js/src/budget/directive/accountSelect.js');
$this->angular('js/src/budget/controller/account/list.js');

$this->angular('js/src/application/query/service/query.js');
